
#ifndef _MOND_
#define _MOND_

/* DO NOT EDIT: generated by rp2gen from mond.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif
#include <rpc2/rpc2.h>
#include <rpc2/se.h>
#include <rpc2/errors.h>
#ifdef __cplusplus
}
#endif

 /* BLURB lgpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2003 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the  terms of the  GNU  Library General Public Licence  Version 2,  as
shown in the file LICENSE. The technical and financial contributors to
Coda are listed in the file CREDITS.

                        Additional copyrights
                           none currently

#*/

#ifndef _vcrcommon_rpc2_
#define _vcrcommon_rpc2_
#include "vcrcommon.h"
#endif /* _vcrcommon_rpc2_ */
#define MondSubsysId	171717
#define MOND_OK	0
#define MOND_CONNECTED	0
#define MOND_OLDVERSION	257
#define MOND_INCOMPATIBLE	258
#define MOND_BADCONNECTION	258
#define MOND_NOTCONNECTED	513
#define MOND_VENUS_CLIENT	1
#define MOND_VICE_CLIENT	2

/* IMPORTANT!  Change this anytime this file is changed! */
#ifdef MOND  /* the real version of the interface understood by mond */
#define MOND_CURRENT_VERSION  26
#endif

/* maintain the following two to reflect which, if any are out of date */
#ifndef MOND
#ifdef VENUS /* we are building a venus */
#define MOND_CURRENT_VERSION 26  /* and it is current */
#else        /* we are building a server */
#define MOND_CURRENT_VERSION 26   /* and it now current as well */
#endif /* VENUS */
#endif /* MOND */

#define nVSEs	41

typedef struct VmonVenusId {
    RPC2_Unsigned IPAddress;
    RPC2_Unsigned BirthTime;
} VmonVenusId;

typedef RPC2_Unsigned VmonSessionId;

typedef struct VmonAVSG {
    RPC2_Unsigned Member0;
    RPC2_Unsigned Member1;
    RPC2_Unsigned Member2;
    RPC2_Unsigned Member3;
    RPC2_Unsigned Member4;
    RPC2_Unsigned Member5;
    RPC2_Unsigned Member6;
    RPC2_Unsigned Member7;
} VmonAVSG;

typedef struct VmonSessionEvent {
    RPC2_Integer Opcode;
    RPC2_Integer SuccessCount;
    RPC2_Unsigned SigmaT;
    RPC2_Unsigned SigmaTSquared;
    RPC2_Integer FailureCount;
} VmonSessionEvent;

typedef struct VmonSessionEventArray {
    VmonSessionEvent Event0;
    VmonSessionEvent Event1;
    VmonSessionEvent Event2;
    VmonSessionEvent Event3;
    VmonSessionEvent Event4;
    VmonSessionEvent Event5;
    VmonSessionEvent Event6;
    VmonSessionEvent Event7;
    VmonSessionEvent Event8;
    VmonSessionEvent Event9;
    VmonSessionEvent Event10;
    VmonSessionEvent Event11;
    VmonSessionEvent Event12;
    VmonSessionEvent Event13;
    VmonSessionEvent Event14;
    VmonSessionEvent Event15;
    VmonSessionEvent Event16;
    VmonSessionEvent Event17;
    VmonSessionEvent Event18;
    VmonSessionEvent Event19;
    VmonSessionEvent Event20;
    VmonSessionEvent Event21;
    VmonSessionEvent Event22;
    VmonSessionEvent Event23;
    VmonSessionEvent Event24;
    VmonSessionEvent Event25;
    VmonSessionEvent Event26;
    VmonSessionEvent Event27;
    VmonSessionEvent Event28;
    VmonSessionEvent Event29;
    VmonSessionEvent Event30;
    VmonSessionEvent Event31;
    VmonSessionEvent Event32;
    VmonSessionEvent Event33;
    VmonSessionEvent Event34;
    VmonSessionEvent Event35;
    VmonSessionEvent Event36;
    VmonSessionEvent Event37;
    VmonSessionEvent Event38;
    VmonSessionEvent Event39;
    VmonSessionEvent Event40;
} VmonSessionEventArray;

typedef struct CacheEventEntry {
    RPC2_Integer Count;
    RPC2_Integer Blocks;
} CacheEventEntry;

typedef struct SessionStatistics {
    RPC2_Integer BytesStart;
    RPC2_Integer BytesEnd;
    RPC2_Integer BytesHighWater;
    RPC2_Integer EntriesStart;
    RPC2_Integer EntriesEnd;
    RPC2_Integer EntriesHighWater;
    RPC2_Integer RecordsCancelled;
    RPC2_Integer RecordsCommitted;
    RPC2_Integer RecordsAborted;
    RPC2_Integer FidsRealloced;
    RPC2_Integer BytesBackFetched;
    RPC2_Integer SystemCPU;
    RPC2_Integer UserCPU;
    RPC2_Integer IdleCPU;
    RPC2_Integer CacheHighWater;
} SessionStatistics;

typedef struct CacheStatistics {
    CacheEventEntry HoardAttrHit;
    CacheEventEntry HoardAttrMiss;
    CacheEventEntry HoardAttrNoSpace;
    CacheEventEntry HoardDataHit;
    CacheEventEntry HoardDataMiss;
    CacheEventEntry HoardDataNoSpace;
    CacheEventEntry NonHoardAttrHit;
    CacheEventEntry NonHoardAttrMiss;
    CacheEventEntry NonHoardAttrNoSpace;
    CacheEventEntry NonHoardDataHit;
    CacheEventEntry NonHoardDataMiss;
    CacheEventEntry NonHoardDataNoSpace;
    CacheEventEntry UnknownHoardAttrHit;
    CacheEventEntry UnknownHoardAttrMiss;
    CacheEventEntry UnknownHoardAttrNoSpace;
    CacheEventEntry UnknownHoardDataHit;
    CacheEventEntry UnknownHoardDataMiss;
    CacheEventEntry UnknownHoardDataNoSpace;
} CacheStatistics;

typedef struct AdviceStatistics {
    RPC2_Integer NotEnabled;
    RPC2_Integer NotValid;
    RPC2_Integer Outstanding;
    RPC2_Integer ASRnotAllowed;
    RPC2_Integer ASRinterval;
    RPC2_Integer VolumeNull;
    RPC2_Integer TotalNumberAttempts;
} AdviceStatistics;

typedef struct AdviceCalls {
    RPC2_Integer success;
    RPC2_Integer failures;
} AdviceCalls;

typedef struct AdviceResults {
    RPC2_Integer count;
} AdviceResults;

typedef struct RvmStatistics {
    RPC2_Integer Malloc;
    RPC2_Integer Free;
    RPC2_Integer FreeBytes;
    RPC2_Integer MallocBytes;
} RvmStatistics;

typedef struct IOT_INFO {
    RPC2_Integer Tid;
    RPC2_Unsigned ResOpt;
    RPC2_Unsigned ElapsedTime;
    RPC2_Integer ReadSetSize;
    RPC2_Integer WriteSetSize;
    RPC2_Integer ReadVolNum;
    RPC2_Integer WriteVolNum;
    RPC2_Unsigned Validation;
    RPC2_Integer InvalidSize;
    RPC2_Integer BackupObjNum;
    RPC2_Unsigned LifeCycle;
    RPC2_Integer PredNum;
    RPC2_Integer SuccNum;
} IOT_INFO;

typedef struct IOT_STAT {
    RPC2_Integer MaxElapsedTime;
    RPC2_Integer AvgElapsedTime;
    RPC2_Integer MaxReadSetSize;
    RPC2_Integer AvgReadSetSize;
    RPC2_Integer MaxWriteSetSize;
    RPC2_Integer AvgWriteSetSize;
    RPC2_Integer MaxReadVolNum;
    RPC2_Integer AvgReadVolNum;
    RPC2_Integer MaxWriteVolNum;
    RPC2_Integer AvgWriteVolNum;
    RPC2_Integer Committed;
    RPC2_Integer Pending;
    RPC2_Integer Resolved;
    RPC2_Integer Repaired;
    RPC2_Integer OCCRerun;
} IOT_STAT;

typedef struct LocalSubtreeStats {
    RPC2_Integer SubtreeNum;
    RPC2_Integer MaxSubtreeSize;
    RPC2_Integer AvgSubtreeSize;
    RPC2_Integer MaxSubtreeHgt;
    RPC2_Integer AvgSubtreeHgt;
    RPC2_Integer MaxMutationNum;
    RPC2_Integer AvgMutationNum;
} LocalSubtreeStats;

typedef struct RepairSessionStats {
    RPC2_Integer SessionNum;
    RPC2_Integer CommitNum;
    RPC2_Integer AbortNum;
    RPC2_Integer CheckNum;
    RPC2_Integer PreserveNum;
    RPC2_Integer DiscardNum;
    RPC2_Integer RemoveNum;
    RPC2_Integer GlobalViewNum;
    RPC2_Integer LocalViewNum;
    RPC2_Integer KeepLocalNum;
    RPC2_Integer ListLocalNum;
    RPC2_Integer NewCommand1Num;
    RPC2_Integer NewCommand2Num;
    RPC2_Integer NewCommand3Num;
    RPC2_Integer NewCommand4Num;
    RPC2_Integer NewCommand5Num;
    RPC2_Integer NewCommand6Num;
    RPC2_Integer NewCommand7Num;
    RPC2_Integer NewCommand8Num;
    RPC2_Integer RepMutationNum;
    RPC2_Integer MissTargetNum;
    RPC2_Integer MissParentNum;
    RPC2_Integer AclDenyNum;
    RPC2_Integer UpdateUpdateNum;
    RPC2_Integer NameNameNum;
    RPC2_Integer RemoveUpdateNum;
} RepairSessionStats;

typedef struct VCBStatistics {
    RPC2_Unsigned Acquires;
    RPC2_Unsigned AcquireObjs;
    RPC2_Unsigned AcquireChecked;
    RPC2_Unsigned AcquireFailed;
    RPC2_Unsigned AcquireNoObjFails;
    RPC2_Unsigned Validates;
    RPC2_Unsigned ValidateObjs;
    RPC2_Unsigned FailedValidates;
    RPC2_Unsigned FailedValidateObjs;
    RPC2_Unsigned Breaks;
    RPC2_Unsigned BreakObjs;
    RPC2_Unsigned BreakVolOnly;
    RPC2_Unsigned BreakRefs;
    RPC2_Unsigned Clears;
    RPC2_Unsigned ClearObjs;
    RPC2_Unsigned ClearRefs;
    RPC2_Unsigned NoStamp;
    RPC2_Unsigned NoStampObjs;
} VCBStatistics;

typedef enum{ ServerDown=0, ServerUp=1 } VmonCommEventType;

typedef enum{ VmonSession=0, VmonCommEvent=1, VmonOverflow=2 } VmonRecordType;

typedef struct VmonMiniCacheStat {
    RPC2_Unsigned Opcode;
    RPC2_Unsigned Entries;
    RPC2_Unsigned SatIntrn;
    RPC2_Unsigned UnsatIntrn;
    RPC2_Unsigned GenIntrn;
} VmonMiniCacheStat;

typedef struct SmonViceId {
    RPC2_Unsigned IPAddress;
    RPC2_Unsigned BirthTime;
} SmonViceId;

typedef struct SmonStatistics {
    RPC2_Integer SystemCPU;
    RPC2_Integer UserCPU;
    RPC2_Integer IdleCPU;
    RPC2_Unsigned BootTime;
    RPC2_Integer TotalIO;
} SmonStatistics;

typedef struct ResOpEntry {
    RPC2_Integer alloccount;
    RPC2_Integer dealloccount;
} ResOpEntry;

typedef struct FileResStats {
    RPC2_Integer Resolves;
    RPC2_Integer NumSucc;
    RPC2_Integer NumConf;
    RPC2_Integer RuntForce;
    RPC2_Integer WeakEq;
    RPC2_Integer NumReg;
    RPC2_Integer UsrResolver;
    RPC2_Integer SuccUsrResolver;
    RPC2_Integer PartialVSG;
} FileResStats;

typedef struct DirResStats {
    RPC2_Integer Resolves;
    RPC2_Integer NumSucc;
    RPC2_Integer NumConf;
    RPC2_Integer NumNoWork;
    RPC2_Integer Problems;
    RPC2_Integer PartialVSG;
} DirResStats;

typedef struct HistoElem {
    RPC2_Integer bucket;
} HistoElem;

typedef struct ResConflictStats {
    RPC2_Integer NameName;
    RPC2_Integer RemoveUpdate;
    RPC2_Integer UpdateUpdate;
    RPC2_Integer Rename;
    RPC2_Integer LogWrap;
    RPC2_Integer Other;
} ResConflictStats;

typedef struct ResLogStats {
    RPC2_Integer NumWraps;
    RPC2_Integer NumAdmGrows;
    RPC2_Integer NumVAllocs;
    RPC2_Integer NumVFrees;
    RPC2_Integer Highest;
} ResLogStats;

typedef struct SpareEntry {
    RPC2_Integer spare;
} SpareEntry;

typedef struct ReadWriteSharingStats {
    RPC2_Integer Vid;
    RPC2_Integer RwSharingCount;
    RPC2_Integer DiscReadCount;
    RPC2_Integer DiscDuration;
} ReadWriteSharingStats;

#define mond_HEAD_VERSION	0

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif /* _STUB_PREDEFINED_ */

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long mond_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

long MondEstablishConn(RPC2_Handle cid, RPC2_Unsigned Version, RPC2_Integer ClientType, RPC2_Integer Expansion_size_, SpareEntry Expansion[]);
#define MondEstablishConn_OP	1
extern ARG MondEstablishConn_ARGS[];
#define MondEstablishConn_PTR	MondEstablishConn_ARGS

long VmonReportSession(RPC2_Handle cid, VmonVenusId *Venus, VmonSessionId Session, VolumeId Volume, UserId User, VmonAVSG *AVSG, RPC2_Unsigned StartTime, RPC2_Unsigned EndTime, RPC2_Unsigned CETime, RPC2_Integer Event_size_, VmonSessionEvent Event[], SessionStatistics *Stats, CacheStatistics *CacheStats);
#define VmonReportSession_OP	2
extern ARG VmonReportSession_ARGS[];
#define VmonReportSession_PTR	VmonReportSession_ARGS

long VmonReportCommEvent(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Unsigned ServerIPAddress, RPC2_Integer SerialNumber, RPC2_Unsigned Time, VmonCommEventType Type);
#define VmonReportCommEvent_OP	3
extern ARG VmonReportCommEvent_ARGS[];
#define VmonReportCommEvent_PTR	VmonReportCommEvent_ARGS

long VmonReportCallEvent(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, RPC2_Integer SrvCount_size_, CallCountEntry SrvCount[]);
#define VmonReportCallEvent_OP	4
extern ARG VmonReportCallEvent_ARGS[];
#define VmonReportCallEvent_PTR	VmonReportCallEvent_ARGS

long VmonReportMCallEvent(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, RPC2_Integer MSrvCount_size_, MultiCallEntry MSrvCount[]);
#define VmonReportMCallEvent_OP	5
extern ARG VmonReportMCallEvent_ARGS[];
#define VmonReportMCallEvent_PTR	VmonReportMCallEvent_ARGS

long VmonReportRVMStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, RvmStatistics *Stats);
#define VmonReportRVMStats_OP	6
extern ARG VmonReportRVMStats_ARGS[];
#define VmonReportRVMStats_PTR	VmonReportRVMStats_ARGS

long VmonReportAdviceStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, UserId User, AdviceStatistics *Stats, RPC2_Integer CallStats_size_, AdviceCalls CallStats[], RPC2_Integer ResultStats_size_, AdviceResults ResultStats[]);
#define VmonReportAdviceStats_OP	7
extern ARG VmonReportAdviceStats_ARGS[];
#define VmonReportAdviceStats_PTR	VmonReportAdviceStats_ARGS

long VmonReportMiniCache(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, RPC2_Integer VnodeOps_size_, VmonMiniCacheStat VnodeOps[], RPC2_Integer VfsOps_size_, VmonMiniCacheStat VfsOps[]);
#define VmonReportMiniCache_OP	8
extern ARG VmonReportMiniCache_ARGS[];
#define VmonReportMiniCache_PTR	VmonReportMiniCache_ARGS

long VmonReportOverflow(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Unsigned VMStartTime, RPC2_Unsigned VMEndTime, RPC2_Integer VMCount, RPC2_Unsigned RVMStartTime, RPC2_Unsigned RVMEndTime, RPC2_Integer RVMCount);
#define VmonReportOverflow_OP	9
extern ARG VmonReportOverflow_ARGS[];
#define VmonReportOverflow_PTR	VmonReportOverflow_ARGS

long SmonNoop(RPC2_Handle cid);
#define SmonNoop_OP	10
extern ARG SmonNoop_ARGS[];
#define SmonNoop_PTR	SmonNoop_ARGS

long SmonReportCallEvent(RPC2_Handle cid, SmonViceId *Vice, RPC2_Unsigned Time, RPC2_Integer CBCount_size_, CallCountEntry CBCount[], RPC2_Integer ResCount_size_, CallCountEntry ResCount[], RPC2_Integer SmonCount_size_, CallCountEntry SmonCount[], RPC2_Integer VolDCount_size_, CallCountEntry VolDCount[], RPC2_Integer MultiCount_size_, MultiCallEntry MultiCount[], SmonStatistics *Stats);
#define SmonReportCallEvent_OP	11
extern ARG SmonReportCallEvent_ARGS[];
#define SmonReportCallEvent_PTR	SmonReportCallEvent_ARGS

long SmonReportResEvent(RPC2_Handle cid, SmonViceId *Vice, RPC2_Unsigned Time, VolumeId Volid, RPC2_Integer HighWaterMark, RPC2_Integer AllocNumber, RPC2_Integer DeallocNumber, RPC2_Integer ResOp_size_, ResOpEntry ResOp[]);
#define SmonReportResEvent_OP	12
extern ARG SmonReportResEvent_ARGS[];
#define SmonReportResEvent_PTR	SmonReportResEvent_ARGS

long SmonReportOverflow(RPC2_Handle cid, SmonViceId *Vice, RPC2_Unsigned Time, RPC2_Unsigned StartTime, RPC2_Unsigned EndTime, RPC2_Integer Count);
#define SmonReportOverflow_OP	13
extern ARG SmonReportOverflow_ARGS[];
#define SmonReportOverflow_PTR	SmonReportOverflow_ARGS

long SmonReportRVMResStats(RPC2_Handle cid, SmonViceId *Vice, RPC2_Unsigned Time, RPC2_Integer VolID, FileResStats *FileRes, DirResStats *DirRes, RPC2_Integer LogSizeHisto_size_, HistoElem LogSizeHisto[], RPC2_Integer LogMaxHisto_size_, HistoElem LogMaxHisto[], ResConflictStats *Conflicts, RPC2_Integer SuccHierHist_size_, HistoElem SuccHierHist[], RPC2_Integer FailHierHist_size_, HistoElem FailHierHist[], ResLogStats *ResLog, RPC2_Integer VarLogHisto_size_, HistoElem VarLogHisto[], RPC2_Integer LogSize_size_, HistoElem LogSize[]);
#define SmonReportRVMResStats_OP	14
extern ARG SmonReportRVMResStats_ARGS[];
#define SmonReportRVMResStats_PTR	SmonReportRVMResStats_ARGS

long VmonReportIotInfo(RPC2_Handle cid, VmonVenusId *Venus, IOT_INFO *Info, RPC2_Integer AppNameLenth, RPC2_String AppName);
#define VmonReportIotInfo_OP	15
extern ARG VmonReportIotInfo_ARGS[];
#define VmonReportIotInfo_PTR	VmonReportIotInfo_ARGS

long VmonReportIotStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, IOT_STAT *Stats);
#define VmonReportIotStats_OP	16
extern ARG VmonReportIotStats_ARGS[];
#define VmonReportIotStats_PTR	VmonReportIotStats_ARGS

long VmonReportSubtreeStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, LocalSubtreeStats *Stats);
#define VmonReportSubtreeStats_OP	17
extern ARG VmonReportSubtreeStats_ARGS[];
#define VmonReportSubtreeStats_PTR	VmonReportSubtreeStats_ARGS

long VmonReportRepairStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, RepairSessionStats *Stats);
#define VmonReportRepairStats_OP	18
extern ARG VmonReportRepairStats_ARGS[];
#define VmonReportRepairStats_PTR	VmonReportRepairStats_ARGS

long VmonReportRwsStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer Time, ReadWriteSharingStats *Stats);
#define VmonReportRwsStats_OP	19
extern ARG VmonReportRwsStats_ARGS[];
#define VmonReportRwsStats_PTR	VmonReportRwsStats_ARGS

long VmonReportVCBStats(RPC2_Handle cid, VmonVenusId *Venus, RPC2_Integer VenusInit, RPC2_Integer Time, VolumeId Volume, VCBStatistics *Stats);
#define VmonReportVCBStats_OP	20
extern ARG VmonReportVCBStats_ARGS[];
#define VmonReportVCBStats_PTR	VmonReportVCBStats_ARGS

#ifdef __cplusplus
}
#endif
#define mondOPARRAYSIZE 21

extern CallCountEntry mond_CallCount[];

extern MultiCallEntry mond_MultiCall[];

extern MultiStubWork mond_MultiStubWork[];

extern long mond_ElapseSwitch;

extern long mond_EnqueueRequest;

#endif /* _MOND_ */
